* COMPM%
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with SMSQ/E and if compiled on Qdos/Minerva
*


        section code

        xdef compm

        xref cmpelm

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err

cstrg   equ $10                 C-string (zero-terminated)
nstrg   equ $12                 N-string (1 byte length)
vtmax   equ $12                 max variable type

*
err_bp
        moveq #err.ipar,d0
*
exit
        rts

*
compm
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* result = COMPM%(X->, Y->, str_cmp.b | var_type.b)
*
* See CMPM_txt for the dirty details
*

        lea.l 3*8(a3),a4        exactly 3 parameters
        cmpa.l a4,a5
        bne.s err_bp

        lea.l 2*8(a3),a4        get last
        exg a4,a3               save a3 for later

        move.w sb.gtint,a2
        jsr (a2)
        bne.s exit

        moveq #0,d7             skip count and a2z flag
        move.b (a6,a1.l),d7     string comp type 0..3

        moveq #$7,d5            mask comptype
        and.b d7,d5             d5 = cmptype

        cmpi.b #3,d5            0..3
        bgt.s err_bp             out of range

        swap d5                 d5: cmptype in place

        bclr #7,d7              is reverse bit set?
        beq.s a2z                no

        bset #31,d5              yes, transfer it

a2z
        lsr.w #3,d7             d7 = skip num

        move.b 1(a6,a1.l),d5
        blt.s err_bp            dont support neg

        cmpi.b #vtmax,d5        max vartype supported (until now)
        bgt.s err_bp

        btst #0,d5              odd numbers invalid (for now)
        bne.s err_bp

        movea.l a3,a5
        movea.l a4,a3           bracket first two pars

        move.w sb.gtlin,a2
        jsr (a2)                clobbers all but d5/d7
        bne.s exit

        move.l 4(a6,a1.l),d1    get pointers
        beq.s err_bp             check theyre not zero

        move.l (a6,a1.l),d0
        beq.s err_bp

        addq.l #8,sb_arthp(a6)  leave room for int return

        move.l d0,a0
        move.l d1,a1

*
        tst.w d7                anything to skip?
        beq.s comp               nope

        cmpi.w #cstrg,d5         yes. c-string?
        beq.s skipc               yep

        cmpi.w #nstrg,d5         no. n-string?
        beq.s skipn               yep

comp
        move.w cmpelm(pc,d5.w),d0       use this routine to
        jsr cmpelm(pc,d0.w)              do the comparison

        tst.l d5                a2z ?
        bpl.s retint             yes

        neg.l d0                 no, z2a

retint
        movea.l sb_arthp(a6),a1
        move.w d0,(a6,a1.l)
        moveq #ar.int,d4
        moveq #0,d0
        rts

*
skipc
        move.w d7,d1
        bra.s skipce0

loopc0
        move.b (a0)+,d0
        bne.s loopc0

skipce0
        dbra d1,loopc0

        move.w d7,d1
        bra.s skipce1

loopc1
        move.b (a1)+,d0
        bne.s loopc1

skipce1
        dbra d1,loopc1

        bra.s comp

*
skipn
        moveq #0,d2
        move.w d7,d1
        bra.s skipne0

loopn0
        move.b (a0)+,d2
        adda.l d2,a0

skipne0
        dbra d1,loopn0

        move.w d7,d1
        subq.w #1,d1

loopn1
        move.b (a1)+,d2
        adda.l d2,a1
        dbra d1,loopn1

        bra.s comp
*
        end
